export declare const checkDelegateForAll: (delegate: string, vault: string) => Promise<boolean>;
export declare const checkDelegateForContract: (delegate: string, vault: string, contract: string) => Promise<boolean>;
export declare const checkDelegateForToken: (delegate: string, vault: string, contract: string, tokenId: number) => Promise<boolean>;
export declare const getContractLevelDelegations: (vault: string) => Promise<{
    contract: string;
    delegate: string;
}[]>;
export declare const getDelegatesForAll: (vault: string) => Promise<string[]>;
export declare const getDelegatesForContract: (vault: string, contract: string) => Promise<string[]>;
export declare const getDelegatesForToken: (vault: string, contract: string, tokenId: number) => Promise<string[]>;
export declare const getDelegationsByDelegate: (delegate: string) => Promise<{
    type: 'NONE' | 'ALL' | 'CONTRACT' | 'TOKEN';
    vault: string;
    delegate: string;
    contract: string;
    tokenId: number;
}[]>;
export declare const getTokenLevelDelegations: (vault: string) => Promise<{
    contract: string;
    tokenId: number;
    delegate: string;
}[]>;
export declare const delegateForAll: (delegate: string, value: boolean) => Promise<any>;
export declare const delegateForContract: (delegate: string, contract: string, value: boolean) => Promise<any>;
export declare const delegateForToken: (delegate: string, contract: string, tokenId: number, value: boolean) => Promise<any>;
export declare const revokeAllDelegates: () => Promise<any>;
export declare const revokeDelegate: (delegate: string) => Promise<any>;
export declare const revokeSelf: (vault: string) => Promise<any>;
export declare const rawDelegateForAll: (delegate: string, value: boolean) => any;
export declare const rawDelegateForContract: (delegate: string, contract: string, value: boolean) => any;
export declare const rawDelegateForToken: (delegate: string, contract: string, tokenId: number, value: boolean) => any;
export declare const rawRevokeAllDelegates: () => any;
export declare const rawRevokeDelegate: (delegate: string) => any;
