import { ethers } from 'ethers';
export var getDelegationType = function (key) {
    var types = ['NONE', 'ALL', 'CONTRACT', 'TOKEN'];
    return types[key] || 'NONE';
};
export var getProvider = function () {
    var _a;
    if (typeof process !== 'undefined' && ((_a = process.env) === null || _a === void 0 ? void 0 : _a.PROVIDER_URL))
        return new ethers.providers.JsonRpcProvider(process.env.PROVIDER_URL);
    // @ts-ignore
    if (typeof window === 'undefined')
        return new ethers.providers.getDefaultProvider();
    // @ts-ignore
    if (window.ethereum) {
        // @ts-ignore
        return new ethers.providers.Web3Provider(window.ethereum);
    }
    return ethers.providers.getDefaultProvider();
};
